(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/material/form-field'), require('rxjs'), require('@angular/cdk/coercion'), require('@angular/cdk/a11y'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-expressions', ['exports', '@angular/core', '@angular/forms', '@angular/material/form-field', 'rxjs', '@angular/cdk/coercion', '@angular/cdk/a11y', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-expressions'] = {}, global.ng.core, global.ng.forms, global.ng.material.formField, global.rxjs, global.ng.cdk.coercion, global.ng.cdk.a11y, global.ng.common));
}(this, (function (exports, core, forms, formField, rxjs, coercion, a11y, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var Formatter = /** @class */ (function () {
        function Formatter() {
        }
        return Formatter;
    }());

    var MONACO_CDN_BASE_URL = 'https://cdnjs.cloudflare.com/ajax/libs/monaco-editor/0.23.0/';
    /**
     * DEFAULT_OPTIONS: monaco.editor.IEditorOptions & monaco.editor.IGlobalEditorOptions
     */
    var DEFAULT_OPTIONS = {
        theme: 'vs',
        language: 'typescript',
        contextmenu: false,
        minimap: {
            enabled: false
        },
        autoIndent: false,
        formatOnPaste: false,
        formatOnType: false,
        renderIndentGuides: false,
        lineNumbers: 'off',
        glyphMargin: false,
        folding: false,
        lineDecorationsWidth: 0,
        lineNumbersMinChars: 0,
        scrollbar: {
            vertical: 'hidden',
            horizontal: 'hidden',
            useShadows: false,
            alwaysConsumeMouseWheel: false,
            handleMouseWheel: false
        },
        wordWrap: 'off',
        overviewRulerBorder: false,
        hideCursorInOverviewRuler: true,
        fontFamily: 'Roboto',
        fontSize: 16,
        fixedOverflowWidgets: true,
        scrollBeyondLastLine: false,
        renderLineHighlight: 'none'
        // renderValidationDecorations: 'off'
    };

    var NGX_EXPRESSIONS_CONFIG = new core.InjectionToken('NGX_EXPRESSIONS_CONFIG');
    var NgxExpressionsConfig = /** @class */ (function () {
        function NgxExpressionsConfig(args) {
            this.monacoBaseUrl = MONACO_CDN_BASE_URL;
            this.monacoDefaultOptions = DEFAULT_OPTIONS;
            this.log = null;
            if (args == null) {
                return;
            }
            if (args.monacoBaseUrl != null) {
                this.monacoBaseUrl = args.monacoBaseUrl;
            }
            if (args.monacoDefaultOptions != null) {
                this.monacoDefaultOptions = args.monacoDefaultOptions;
            }
            if (args.configure != null) {
                this.configure = args.configure;
            }
            if (args.log != null) {
                this.log = args.log;
            }
        }
        return NgxExpressionsConfig;
    }());

    var MONACO_PATH = 'min/vs';
    var MONACO_EDITOR_PATH = 'min/vs/editor/editor.main';
    var MonacoLoaderService = /** @class */ (function () {
        function MonacoLoaderService(config) {
            this.config = config;
            this.isReady = false;
            if (this.config != null && this.config.monacoBaseUrl != null) {
                this.baseUrl = this.config.monacoBaseUrl;
            }
            else {
                this.baseUrl = MONACO_CDN_BASE_URL;
            }
        }
        MonacoLoaderService.prototype.createEditor = function (element, code, language) {
            if (language === void 0) { language = 'typescript'; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.loadRequire()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, window.monaco.editor.create(element, {
                                    language: language
                                })];
                    }
                });
            });
        };
        MonacoLoaderService.prototype.loadRequire = function () {
            return __awaiter(this, void 0, void 0, function () {
                var proxy;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(window.require != null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.waitForNamespace(function (window) { return window.monaco != null; })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, true];
                        case 2:
                            this.addScript(this.baseUrl + "min/vs/loader.js");
                            return [4 /*yield*/, this.waitForNamespace(function (window) { return window.require != null; })];
                        case 3:
                            _a.sent();
                            window.require.config({ paths: { vs: "" + this.baseUrl + MONACO_PATH } });
                            window.require(["" + this.baseUrl + MONACO_EDITOR_PATH], function () { });
                            return [4 /*yield*/, this.waitForNamespace(function (window) { return window.monaco != null; })];
                        case 4:
                            _a.sent();
                            window.MonacoEnvironment = {
                                getWorkerUrl: function () { return proxy; }
                            };
                            proxy = URL.createObjectURL(new Blob([
                                "\tself.MonacoEnvironment = {\n\t\tbaseUrl: '" + this.baseUrl + "min/'\n\t};\n\timportScripts('" + this.baseUrl + "min/vs/base/worker/workerMain.js');"
                            ], { type: 'text/javascript' }));
                            if (!(this.config != null && this.config.configure != null)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.config.configure(window.monaco)];
                        case 5:
                            _a.sent();
                            _a.label = 6;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        MonacoLoaderService.prototype.waitForNamespace = function (check, timeout) {
            if (timeout === void 0) { timeout = 60000; }
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                                var wait, timeoutTimer;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            wait = true;
                                            timeoutTimer = setTimeout(function () {
                                                console.error('Timeout waiting for monaco to become ready');
                                                wait = false;
                                                reject('Timeout');
                                            }, timeout);
                                            _a.label = 1;
                                        case 1:
                                            if (!(wait === true)) return [3 /*break*/, 3];
                                            if (check(window) === true) {
                                                clearTimeout(timeoutTimer);
                                                return [2 /*return*/, resolve()];
                                            }
                                            return [4 /*yield*/, new Promise(function (wake) {
                                                    setTimeout(function () {
                                                        wake();
                                                    }, 500);
                                                })];
                                        case 2:
                                            _a.sent();
                                            return [3 /*break*/, 1];
                                        case 3:
                                            resolve();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        MonacoLoaderService.prototype.addScript = function (scriptUrl) {
            var element = document.createElement('script');
            element.type = 'text/javascript';
            element.src = scriptUrl;
            element.addEventListener('load', function (ev) { });
            document.body.appendChild(element);
        };
        return MonacoLoaderService;
    }());
    MonacoLoaderService.decorators = [
        { type: core.Injectable }
    ];
    MonacoLoaderService.ctorParameters = function () { return [
        { type: NgxExpressionsConfig, decorators: [{ type: core.Inject, args: [NGX_EXPRESSIONS_CONFIG,] }] }
    ]; };

    var EditorComponent = /** @class */ (function () {
        function EditorComponent(elementRef, monacoLoader) {
            this.elementRef = elementRef;
            this.monacoLoader = monacoLoader;
            this.language = 'typescript';
            this.monacoOptions = DEFAULT_OPTIONS;
            this.editorReady = new core.EventEmitter();
            this.valueChanged = new core.EventEmitter();
            this.validationChange = new core.EventEmitter();
        }
        Object.defineProperty(EditorComponent.prototype, "id", {
            get: function () {
                if (this._id == null) {
                    this._id = "code-" + EditorComponent._identity;
                    EditorComponent._identity++;
                }
                return this._id;
            },
            enumerable: false,
            configurable: true
        });
        EditorComponent.prototype.ngAfterViewInit = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _a = this;
                            return [4 /*yield*/, this.monacoLoader.createEditor(this.codeRef.nativeElement, '', this.language)];
                        case 1:
                            _a.editor = _b.sent();
                            this.editor.updateOptions(this.monacoOptions);
                            return [4 /*yield*/, this.init()];
                        case 2:
                            _b.sent();
                            this.editorReady.emit(this.editor);
                            return [2 /*return*/];
                    }
                });
            });
        };
        EditorComponent.prototype.ngOnDestroy = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (this.editor != null) {
                        this.editor.dispose();
                        this.editor = undefined;
                    }
                    return [2 /*return*/];
                });
            });
        };
        EditorComponent.prototype.init = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    this.editor.onKeyUp(function (e) {
                        _this.valueChanged.emit(_this.editor.getModel().getValue());
                    });
                    this.editor.onDidChangeModelDecorations(function (e) {
                        setTimeout(function () {
                            var model = _this.editor.getModel();
                            if (model === null || model.getModeId() !== 'typescript') {
                                return;
                            }
                            var owner = model.getModeId();
                            var markers = window.monaco.editor.getModelMarkers({ owner: owner });
                            var errors = markers
                                .filter(function (i) { return i.severity > 1 && i.resource.path === "/" + _this.id; })
                                .map(function (i) { return i; })
                                .map(function (i) { return i.message; });
                        }, 100);
                        // const owner = model.getModeId();
                        // const markers = this.editor.getModel()..getModelMarkers({ owner: 'typescript' });
                        // for (const x of markers) {
                        //     console.log('x', x);
                        // }
                        // this.validationChange.emit(markers.map((i) => i.message));
                    });
                    return [2 /*return*/];
                });
            });
        };
        return EditorComponent;
    }());
    EditorComponent._identity = 1000;
    EditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'expr-editor',
                    template: "<div class=\"expr editor\" #codeRef [attr.id]=\"id\"></div>\n",
                    styles: [".expr.editor{display:block;height:calc(100% + 100px);min-height:100px}.expr.editor ::ng-deep .monaco-editor,.expr.editor ::ng-deep .monaco-editor-background{background-color:transparent!important}.expr.editor ::ng-deep .decorationsOverviewRuler{display:none}"]
                },] }
    ];
    EditorComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: MonacoLoaderService }
    ]; };
    EditorComponent.propDecorators = {
        codeRef: [{ type: core.ViewChild, args: ['codeRef',] }],
        language: [{ type: core.Input }],
        monacoOptions: [{ type: core.Input }],
        editorReady: [{ type: core.Output }],
        valueChanged: [{ type: core.Output }],
        validationChange: [{ type: core.Output }]
    };

    var INTERPOLATION_REGEX = /^(\((.*?)\):\s?\w*\s?=>\s?\{\s*return\s*\(`?\s*?)\n(.*?)\n(`?\);\s*\})\s*$/s;
    var EXPRESSION_REGEX = /^(\((.*?)\):\s?\w*\s?=>\s?\{\s*return\s*\(?\s*?)\n(.*?)\n(\);\s*\})\s*$/s;
    var EXTENDED_REGEX = /^(\((.*?)\):\s?\w*\s?=>\s?\{\s*\(?\s*?)\n(.*?)\n(\})\s*$/s;
    var GENERIC_PARSER = function (log, regex, model) {
        var fullCode = model.getValue();
        if (!fullCode.match(regex)) {
            regex.lastIndex = 0;
            var failedGroups = regex.exec(fullCode);
            console.warn('Failed to parse code', { failedGroups: failedGroups, fullCode: fullCode, regex: regex });
            return null;
        }
        regex.lastIndex = 0;
        var groups = regex.exec(fullCode);
        if (groups == null) {
            return null;
        }
        var begin = groups[1] || '';
        var parameters = groups[2] || '';
        var targetCode = groups[3] || '';
        var end = groups[4] || '';
        var headerRange = null;
        var targetRange = null;
        var endRange = null;
        var beginMatch = model.findNextMatch(begin, new window.monaco.Position(1, 1), false, true, null, false);
        if (beginMatch != null && beginMatch.range != null) {
            headerRange = beginMatch.range;
        }
        else {
            throw new Error('Cannot match header');
        }
        var targetMatch = model.findNextMatch(targetCode, headerRange.getEndPosition(), false, true, null, false);
        if (targetCode != null && targetCode.length > 0) {
            if (targetMatch != null && targetMatch.range != null) {
                targetRange = targetMatch.range;
            }
            else {
                if (log != null) {
                    log('Cannot match target', [targetCode, groups]);
                }
                throw new Error('Cannot match target');
            }
        }
        else {
            targetRange = new window.monaco.Range(3, 1, 3, 1);
        }
        var endMatch = model.findNextMatch(end, targetRange.getEndPosition(), false, true, null, false);
        if (endMatch != null && endMatch.range != null) {
            endRange = window.monaco.Range.fromPositions(new window.monaco.Position(targetRange.endLineNumber + 1, 1), endMatch.range.getEndPosition());
        }
        else {
            throw new Error('Cannot match end');
        }
        var startingPosition = targetRange.getStartPosition();
        var workingRange = window.monaco.Range.fromPositions(startingPosition, endRange.getStartPosition());
        return {
            fullCode: fullCode,
            targetCode: targetCode,
            fullLineCount: fullCode.split(/\r\n|\r|\n/).length,
            targetLineCount: targetCode.split(/\r\n|\r|\n/).length,
            headerRange: headerRange,
            workingRange: workingRange,
            footerRange: endRange,
            parameters: parameters,
            startingPosition: startingPosition
        };
    };
    var ɵ0 = function (parameters, returnType, targetCode) {
        if (targetCode == null || targetCode.length === 0) {
            targetCode = '';
        }
        if (returnType !== 'string') {
            returnType = 'string';
        }
        return "(" + parameters + "): " + returnType + " => {\nreturn (`\n" + targetCode + "\n`);\n}\n";
    }, ɵ1 = function (parameters, returnType, targetCode) {
        if (targetCode == null || targetCode.length === 0) {
            targetCode = '';
        }
        return "(" + parameters + "): " + returnType + " => {\nreturn (\n" + targetCode + "\n);\n}\n";
    }, ɵ2 = function (parameters, returnType, targetCode) {
        if (targetCode == null || targetCode.length === 0) {
            targetCode = '';
        }
        return "(" + parameters + "): " + returnType + " => {\n" + targetCode + "\n}";
    };
    var FORMAT_RULES = {
        typescript: {
            interpolation: {
                regex: INTERPOLATION_REGEX,
                getTemplate: ɵ0,
                parseTemplate: GENERIC_PARSER
            },
            expression: {
                regex: EXPRESSION_REGEX,
                getTemplate: ɵ1,
                parseTemplate: GENERIC_PARSER
            },
            extended: {
                regex: EXTENDED_REGEX,
                getTemplate: ɵ2,
                parseTemplate: GENERIC_PARSER
            }
        }
    };

    var FormatterService = /** @class */ (function () {
        function FormatterService(config) {
            this.config = config;
            this.logger = null;
            if (this.config != null && this.config.log != null) {
                this.logger = this.config.log;
            }
        }
        FormatterService.prototype.parseModel = function (language, formatRuleName, model) {
            if (model == null) {
                return null;
            }
            if (this.previousFullCode === model.getValue()) {
                return this.previousParseResult;
            }
            this.previousFullCode = model.getValue();
            var rule = this.getRule(language, formatRuleName);
            this.previousParseResult = rule.parseTemplate(this.logger, rule.regex, model);
            if (this.config != null && this.config.log != null) {
                // tslint:disable-next-line:no-console
                this.config.log('NgxExpressions Parse Result', [this.previousParseResult]);
            }
            return this.previousParseResult;
        };
        FormatterService.prototype.getTemplate = function (language, formatRuleName, parameters, returnType, targetCode) {
            var rule = this.getRule(language, formatRuleName);
            if (rule == null) {
                throw new Error("Invalid formatRuleName '" + formatRuleName + "'");
            }
            rule.regex.lastIndex = 0;
            if (targetCode != null && targetCode.trim().length > 0 && targetCode.match(rule.regex)) {
                this.log('Provided code already matches template.', targetCode);
                return targetCode;
            }
            return rule.getTemplate(parameters, returnType, targetCode || '');
        };
        FormatterService.prototype.setHiddenRanges = function (editor, parseResult) {
            this.log('NgxExpressions setHiddenRanges', {
                editor: editor,
                parseResult: parseResult
            });
            if (parseResult == null) {
                return;
            }
            editor.setHiddenAreas([parseResult.headerRange, parseResult.footerRange]);
            editor.revealPositionNearTop(editor.getPosition(), window.monaco.editor.ScrollType.Immediate);
        };
        FormatterService.prototype.updatedCursorPosition = function (editor, parseResult, e) {
            this.log('NgxExpressions updatedCursorPosition', {
                editor: editor,
                parseResult: parseResult
            });
            if (parseResult == null) {
                return;
            }
            if (parseResult.workingRange == null) {
                editor.setPosition(parseResult.startingPosition);
                editor.setScrollPosition({
                    scrollTop: 0,
                    scrollLeft: 0
                });
                editor.revealPositionNearTop(new window.monaco.Position(1, 1));
            }
            else {
                if (!parseResult.workingRange.containsPosition(e.position)) {
                    if (e.position.isBefore(parseResult.workingRange.getStartPosition())) {
                        editor.revealPositionNearTop(parseResult.workingRange.getStartPosition());
                    }
                    else {
                        var end = parseResult.workingRange.getEndPosition();
                        editor.setPosition(end);
                    }
                }
                editor.revealPositionNearTop(editor.getPosition(), window.monaco.editor.ScrollType.Immediate);
            }
        };
        FormatterService.prototype.updatedCursorSelection = function (editor, parseResult, e) {
            this.log('NgxExpressions updatedCursorSelection', {
                editor: editor,
                parseResult: parseResult
            });
            if (e.source === 'api' || e.reason === window.monaco.editor.CursorChangeReason.NotSet) {
                return;
            }
            if (e.selection.isEmpty()) {
                return;
            }
            if (parseResult == null) {
                return;
            }
            if (parseResult.workingRange == null) {
                editor.setSelection(window.monaco.Selection.fromPositions(parseResult.headerRange.getEndPosition(), parseResult.headerRange.getEndPosition()));
                editor.revealPositionNearTop(editor.getPosition(), window.monaco.editor.ScrollType.Immediate);
                return;
            }
            var selection = e.selection;
            var update = false;
            if (selection.intersectRanges(parseResult.headerRange)) {
                update = true;
                selection = selection.setStartPosition(parseResult.headerRange.endLineNumber + 1, 1);
            }
            if (selection.intersectRanges(parseResult.footerRange)) {
                update = true;
                selection = selection.setEndPosition(parseResult.footerRange.startLineNumber - 1, editor.getModel().getLineLength(parseResult.footerRange.startLineNumber - 1) + 1);
            }
            if (update) {
                editor.setSelection(selection);
            }
            editor.revealPositionNearTop(editor.getPosition(), window.monaco.editor.ScrollType.Immediate);
        };
        FormatterService.prototype.updateScrollPosition = function (editor, parseResult) {
            editor.revealPositionNearTop(editor.getPosition(), window.monaco.editor.ScrollType.Immediate);
        };
        FormatterService.prototype.updateModelDecorations = function (editor, parseResult, editorId, e) {
            this.log('NgxExpressions updateModelDecorations', {
                editor: editor,
                parseResult: parseResult
            });
            if (parseResult == null) {
                return;
            }
            var model = editor.getModel();
            if (model === null || model.getModeId() !== 'typescript') {
                return [];
            }
            var owner = model.getModeId();
            var markers = window.monaco.editor.getModelMarkers({ owner: owner });
            this.log('NgxExpressions updateModelDecorations markers', {
                markers: markers
            });
            return markers
                .filter(function (i) { return i.severity > 1 && i.resource.path === editor.getModel().uri.path; })
                .map(function (i) { return i.message; });
        };
        FormatterService.prototype.isKeypressAllowed = function (editor, parseResult, e, autoExpand) {
            if (autoExpand === void 0) { autoExpand = false; }
            this.log('NgxExpressions isKeypressAllowed', {
                editor: editor,
                parseResult: parseResult
            });
            if (parseResult == null) {
                return;
            }
            if (e.code === 'Enter' && autoExpand === false) {
                return false;
            }
            else if (e.code.startsWith('F') && e.code.length === 2) {
                return false;
            }
            else if (e.code === 'Delete' && !this.isDeleteKeyAllowed(editor, parseResult)) {
                return false;
            }
            else if (e.code === 'Backspace' && !this.isBackspaceKeyAllowed(editor, parseResult)) {
                return false;
            }
            return true;
        };
        FormatterService.prototype.isDeleteKeyAllowed = function (editor, parseResult) {
            this.log('NgxExpressions isDeleteKeyAllowed', {
                editor: editor,
                parseResult: parseResult
            });
            if (parseResult == null) {
                return;
            }
            var position = editor.getPosition();
            return (position.lineNumber < parseResult.fullLineCount - 3 ||
                (position.lineNumber === parseResult.fullLineCount - 3 &&
                    position.column <= editor.getModel().getLineLength(position.lineNumber)) ||
                !editor.getSelection().isEmpty());
        };
        FormatterService.prototype.isBackspaceKeyAllowed = function (editor, parseResult) {
            this.log('NgxExpressions isBackspaceKeyAllowed', {
                editor: editor,
                parseResult: parseResult
            });
            if (parseResult == null) {
                return;
            }
            var position = editor.getPosition();
            return new window.monaco.Position(3, 1).isBefore(position);
        };
        FormatterService.prototype.getRule = function (language, formatRuleName) {
            if (FORMAT_RULES[language] == null) {
                throw new Error("Formatting rules for language '" + language + "' are not implemented.");
            }
            var rule = FORMAT_RULES[language][formatRuleName];
            if (rule == null) {
                throw new Error("Invalid formatter rule name " + formatRuleName);
            }
            return rule;
        };
        FormatterService.prototype.log = function (message) {
            var params = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                params[_i - 1] = arguments[_i];
            }
            if (this.config != null && this.config.log != null) {
                this.config.log(message, params);
            }
        };
        return FormatterService;
    }());
    FormatterService.decorators = [
        { type: core.Injectable }
    ];
    FormatterService.ctorParameters = function () { return [
        { type: NgxExpressionsConfig, decorators: [{ type: core.Inject, args: [NGX_EXPRESSIONS_CONFIG,] }] }
    ]; };

    var SINGLE_LINE_HEIGHT_PX = 22;
    var MAX_VISIBLE_LINE_COUNT = 8;
    var InputComponent = /** @class */ (function () {
        function InputComponent(config, focusMonitor, elementRef, ngControl, formatter) {
            this.config = config;
            this.focusMonitor = focusMonitor;
            this.elementRef = elementRef;
            this.ngControl = ngControl;
            this.formatter = formatter;
            this.language = 'typescript';
            this.output = 'template';
            this.describedBy = '';
            this.id = "expr-input-" + ++InputComponent.nextId;
            this.autofilled = false;
            this.controlType = 'expression';
            this.stateChanges = new rxjs.Subject();
            this._parameters = '';
            this._mode = 'interpolation';
            this._returnType = 'string';
            this._validations = [];
            this._busy = true;
            this._disabled = false;
            this._focused = false;
            this._placeholder = '';
            this._required = false;
            this._destroy = new rxjs.Subject();
            this._autosize = false;
            if (ngControl) {
                // Set the value accessor directly (instead of providing
                // NG_VALUE_ACCESSOR) to avoid running into a circular import
                this.ngControl.valueAccessor = this;
                ngControl.valueAccessor = this;
            }
        }
        Object.defineProperty(InputComponent.prototype, "busy", {
            get: function () {
                return this._busy === true;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "returnType", {
            get: function () {
                return this._returnType;
            },
            set: function (value) {
                var targetCode = this.getTargetCode();
                this._returnType = value;
                this.writeValue(targetCode);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "disabled", {
            get: function () {
                return this._disabled;
            },
            set: function (value) {
                this._disabled = coercion.coerceBooleanProperty(value);
                this.stateChanges.next();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "placeholder", {
            get: function () {
                return this._placeholder;
            },
            set: function (value) {
                this._placeholder = value;
                this.stateChanges.next();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "autosize", {
            get: function () {
                if (this.mode === 'extended') {
                    return true;
                }
                return this._autosize;
            },
            set: function (value) {
                var _this = this;
                this._autosize = value;
                setTimeout(function () {
                    _this.updateLayout();
                }, 50);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "required", {
            get: function () {
                return this._required;
            },
            set: function (value) {
                this._required = coercion.coerceBooleanProperty(value);
                this.stateChanges.next();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "value", {
            get: function () {
                var parsed = this.getParseResult();
                if (parsed == null) {
                    return null;
                }
                if (this.output === 'template') {
                    return parsed.targetCode;
                }
                else if (this.output === 'function') {
                    return parsed.fullCode;
                }
                throw new Error("Output mode '" + this.output + "' not implemented!");
            },
            set: function (value) {
                this.writeValue(value);
                this.stateChanges.next();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "shouldLabelFloat", {
            get: function () {
                return this.focused || !this.empty || this.busy;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "validationErrors", {
            get: function () {
                return this._validations;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "styles", {
            get: function () {
                if (this.autosize === false) {
                    return null;
                }
                var parsed = this.getParseResult();
                if (parsed != null && parsed.targetLineCount > 1) {
                    var height = parsed.targetLineCount * SINGLE_LINE_HEIGHT_PX;
                    return {
                        height: height + "px"
                    };
                }
                return null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "scrolling", {
            get: function () {
                if (this.autosize === false) {
                    return false;
                }
                var parsed = this.getParseResult();
                if (parsed == null) {
                    return false;
                }
                return parsed.targetLineCount > MAX_VISIBLE_LINE_COUNT;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "empty", {
            get: function () {
                return (this._value == null ||
                    this._parseResult == null ||
                    this._parseResult.targetCode == null ||
                    this._parseResult.targetCode.trim().length === 0);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "errorState", {
            get: function () {
                var parsed = this.getParseResult();
                if (this.required === true || (parsed != null && parsed.targetCode.trim().length > 0)) {
                    if (this._validations == null) {
                        return false;
                    }
                    return this._validations.length > 0;
                }
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "focused", {
            get: function () {
                return this._focused;
            },
            set: function (value) {
                this._focused = value;
                if (this._focused === true) {
                    this.updateLayout();
                }
                else {
                    this.reloadParseResult();
                }
                this.stateChanges.next();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "parameters", {
            get: function () {
                return this._parameters;
            },
            set: function (value) {
                var targetCode = this.getTargetCode();
                this._parameters = value;
                this.writeValue(targetCode);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(InputComponent.prototype, "mode", {
            get: function () {
                return this._mode;
            },
            set: function (value) {
                var targetCode = this.getTargetCode();
                this._mode = value;
                this.writeValue(targetCode);
            },
            enumerable: false,
            configurable: true
        });
        InputComponent.prototype.updateLayout = function () {
            this.updateHiddenRanges();
            if (this.editorRef == null || this.editorRef.editor == null) {
                return;
            }
            this.editorRef.editor.layout();
            this.editorRef.elementRef.nativeElement.scrollTop = 0;
        };
        InputComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.focusMonitor.monitor(this.elementRef.nativeElement, true).subscribe(function (focusOrigin) {
                _this.focused = !!focusOrigin;
            });
        };
        InputComponent.prototype.ngOnDestroy = function () {
            this._destroy.next();
            this._destroy.complete();
            this.stateChanges.complete();
            this.focusMonitor.stopMonitoring(this.elementRef.nativeElement);
        };
        InputComponent.prototype.onContainerClick = function (event) {
            if (event.target.tagName.toLowerCase() !== 'input') {
                this.focusMonitor.focusVia(this.editorRef.codeRef.nativeElement, 'mouse');
            }
        };
        InputComponent.prototype.onEditorReady = function () {
            return __awaiter(this, void 0, void 0, function () {
                var parsed;
                var _this = this;
                return __generator(this, function (_a) {
                    this.addListeners();
                    this.applyValue();
                    parsed = this.getParseResult();
                    if (parsed != null) {
                        this.editorRef.editor.setPosition(parsed.startingPosition);
                    }
                    setTimeout(function () {
                        _this.updateLayout();
                    }, 50);
                    this._busy = false;
                    return [2 /*return*/];
                });
            });
        };
        InputComponent.prototype.registerOnChange = function (onChange) {
            this._onChange = onChange;
        };
        InputComponent.prototype.registerOnTouched = function (onTouched) {
            this._onTouched = onTouched;
        };
        InputComponent.prototype.setDescribedByIds = function (ids) {
            this.describedBy = ids.join(' ');
        };
        InputComponent.prototype.setDisabledState = function (shouldDisable) {
            this.editorRef.editor.updateOptions({ readOnly: shouldDisable });
            this.disabled = shouldDisable;
        };
        InputComponent.prototype.writeValue = function (value) {
            this._value = this.formatter.getTemplate(this.language, this.mode, this.parameters, this.returnType, value || '');
            this.applyValue();
        };
        InputComponent.prototype.onTouched = function () {
            if (this._onTouched != null) {
                this._onTouched();
            }
        };
        InputComponent.prototype.onChange = function (value) {
            if (this._onChange != null) {
                this._onChange(value || '');
            }
        };
        InputComponent.prototype.applyValue = function () {
            if (this.editorRef == null ||
                this.editorRef.editor == null ||
                this._value == null ||
                this._value.length === 0) {
                return;
            }
            var model = this.editorRef.editor.getModel();
            if (model == null) {
                model = window.monaco.editor.createModel(this._value, this.language, window.monaco.Uri.parse("inmemory://" + this.id + ".ts"));
                this.editorRef.editor.setModel(model);
            }
            else {
                model.setValue(this._value);
            }
            this.formatter.setHiddenRanges(this.editorRef.editor, this.reloadParseResult());
        };
        InputComponent.prototype.addListeners = function () {
            var _this = this;
            if (this.editorRef == null || this.editorRef.editor == null) {
                throw new Error('Cannot add listeners as editor not ready.');
            }
            this.editorRef.editor.onDidChangeModelContent(function (e) {
                _this.formatter.setHiddenRanges(_this.editorRef.editor, _this.reloadParseResult());
                var parsed = _this.getParseResult();
                if (parsed != null) {
                    _this.onChange(parsed.targetCode);
                }
            });
            this.editorRef.editor.onDidChangeCursorPosition(function (e) {
                _this.formatter.updatedCursorPosition(_this.editorRef.editor, _this.getParseResult(), e);
                _this.onTouched();
            });
            this.editorRef.editor.onDidChangeCursorSelection(function (e) {
                _this.formatter.updatedCursorSelection(_this.editorRef.editor, _this.getParseResult(), e);
                _this.onTouched();
            });
            this.editorRef.editor.onKeyDown(function (e) {
                if (_this.formatter.isKeypressAllowed(_this.editorRef.editor, _this.getParseResult(), e, _this.autosize) ===
                    false) {
                    e.stopPropagation();
                    e.preventDefault();
                }
                _this.onTouched();
            });
            this.editorRef.editor.onDidScrollChange(function (e) {
                _this.formatter.updateScrollPosition(_this.editorRef.editor, _this.getParseResult());
            });
            this.editorRef.editor.onDidChangeModelDecorations(function (e) {
                _this._validations = _this.formatter.updateModelDecorations(_this.editorRef.editor, _this.getParseResult(), _this.id, e);
                if (_this.validationErrors != null && _this.validationErrors.length > 0) {
                    _this.onChange(_this._value);
                }
            });
        };
        InputComponent.prototype.reloadParseResult = function () {
            if (this.editorRef == null || this.editorRef.editor == null) {
                return null;
            }
            var lineCount = this._parseResult != null ? this._parseResult.targetLineCount : -1;
            this._parseResult = this.formatter.parseModel(this.language, this.mode, this.editorRef.editor.getModel());
            if (this._parseResult != null && this._parseResult.targetLineCount !== lineCount) {
                this.updateLayout();
            }
            return this._parseResult;
        };
        InputComponent.prototype.getParseResult = function () {
            if (this._parseResult != null) {
                return this._parseResult;
            }
            return this.reloadParseResult();
        };
        InputComponent.prototype.updateHiddenRanges = function () {
            this.formatter.setHiddenRanges(this.editorRef.editor, this.getParseResult());
        };
        InputComponent.prototype.getTargetCode = function () {
            var parsed = this.reloadParseResult();
            if (parsed == null) {
                return '';
            }
            return parsed.targetCode;
        };
        return InputComponent;
    }());
    InputComponent.nextId = 0;
    InputComponent.decorators = [
        { type: core.Component, args: [{
                    providers: [{ provide: formField.MatFormFieldControl, useExisting: InputComponent }],
                    selector: 'expr-input',
                    template: "<div\n    class=\"expr input\"\n    [class.busy]=\"busy === true\"\n    [class.disabled]=\"disabled === true\"\n    [class.primary]=\"color === 'primary'\"\n    [class.accent]=\"color === 'accent'\"\n    [class.autosize]=\"autosize === true\"\n    [class.scrolling]=\"scrolling === true\"\n    [ngClass]=\"mode\"\n    [ngStyle]=\"styles\"\n>\n    <expr-editor #editorRef [language]=\"language\" (editorReady)=\"onEditorReady()\" [ngStyle]=\"styles\"></expr-editor>\n    <div class=\"overlay\"></div>\n    <div class=\"spinner\"><i></i></div>\n</div>\n",
                    styles: [".expr.input{position:relative;width:100%;min-height:22px;line-height:22px;height:22px;overflow:hidden;margin-bottom:-7px}.expr.input ::ng-deep .monaco-editor .scrollbar{display:none!important}.expr.input.autosize.scrolling .monaco-editor .scrollbar{display:inherit!important}.expr.input .overlay,.expr.input expr-editor{transition:opacity .3s ease;display:block}.expr.input expr-editor{opacity:1}.expr.input .overlay,.expr.input .spinner{display:none;opacity:0}.expr.input .overlay{position:absolute;top:0;bottom:0;left:0;right:0;z-index:9998}.expr.input .spinner{position:absolute;top:0;left:0;width:22px;height:22px}.expr.input .spinner i{position:absolute;top:0;left:4px;display:inline-block;width:16px;height:16px;-webkit-animation:circ-anim .7s linear infinite;animation:circ-anim .7s linear infinite;border-radius:50%;border-right:2px solid transparent;border-top:1px solid grey;transform-origin:center;z-index:9999}@-webkit-keyframes circ-anim{0%{transform:rotate(0)}to{transform:rotate(1turn)}}@keyframes circ-anim{0%{transform:rotate(0)}to{transform:rotate(1turn)}}.expr.input.busy expr-editor{opacity:0}.expr.input.busy .overlay,.expr.input.busy .spinner{display:block;opacity:1;z-index:99999}.expr.input.disabled expr-editor{opacity:.8}.expr.input.disabled .overlay{display:block;z-index:99999}.expr.input ::ng-deep .mtk1{color:#2d2d2d!important}.expr.input ::ng-deep .mtk20{color:#474747!important}"]
                },] }
    ];
    InputComponent.ctorParameters = function () { return [
        { type: NgxExpressionsConfig, decorators: [{ type: core.Inject, args: [NGX_EXPRESSIONS_CONFIG,] }] },
        { type: a11y.FocusMonitor },
        { type: core.ElementRef },
        { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] },
        { type: FormatterService }
    ]; };
    InputComponent.propDecorators = {
        returnType: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        placeholder: [{ type: core.Input }],
        autosize: [{ type: core.Input }],
        required: [{ type: core.Input }],
        value: [{ type: core.Input }],
        shouldLabelFloat: [{ type: core.HostBinding, args: ['class.floating',] }],
        editorRef: [{ type: core.ViewChild, args: ['editorRef',] }],
        color: [{ type: core.Input }],
        parameters: [{ type: core.Input }],
        mode: [{ type: core.Input }],
        output: [{ type: core.Input }],
        describedBy: [{ type: core.HostBinding, args: ['attr.aria-describedby',] }],
        id: [{ type: core.HostBinding }],
        updateLayout: [{ type: core.HostListener, args: ['window:resize', ['$event'],] }],
        onTouched: [{ type: core.HostListener, args: ['focusout',] }]
    };

    var NgxExpressionsModule = /** @class */ (function () {
        function NgxExpressionsModule() {
        }
        NgxExpressionsModule.forRoot = function (args) {
            return {
                ngModule: NgxExpressionsModule,
                providers: [
                    MonacoLoaderService,
                    FormatterService,
                    {
                        provide: NGX_EXPRESSIONS_CONFIG,
                        useValue: args
                    }
                ]
            };
        };
        return NgxExpressionsModule;
    }());
    NgxExpressionsModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [EditorComponent, InputComponent],
                    exports: [InputComponent],
                    imports: [common.CommonModule, forms.FormsModule, formField.MatFormFieldModule]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.InputComponent = InputComponent;
    exports.NGX_EXPRESSIONS_CONFIG = NGX_EXPRESSIONS_CONFIG;
    exports.NgxExpressionsConfig = NgxExpressionsConfig;
    exports.NgxExpressionsModule = NgxExpressionsModule;
    exports.ɵa = EditorComponent;
    exports.ɵb = InputComponent;
    exports.ɵc = FormatterService;
    exports.ɵd = MonacoLoaderService;
    exports.ɵe = FormatterService;
    exports.ɵf = NGX_EXPRESSIONS_CONFIG;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-expressions.umd.js.map
